#pragma once

#include <tchar.h>
#include <Windows.h>
#include "constants.hpp"
#include "KeyBind.hpp"

/**
 * L[oChݒEBhE
 */
class KeyBindWindow
{
public:

	/**
	 * RXgN^
	 *
	 * @param instanceHandle AvP[ṼCX^Xnh
	 * @param parentWindowHandle eEBhẼnh
	 * @param keyBind L[oCh
	 */
	KeyBindWindow(HINSTANCE instanceHandle, HWND parentWindowHandle, KeyBind* keyBind);

	/**
	 * fXgN^
	 */
	~KeyBindWindow();

	/**
	 * EBhȄ
	 *
	 * 1xsȂ
	 * 2ڈȍ~̌Ăяo͉sȂ
	 *
	 * @return ɏIꍇtrueԂ
	 */
	bool initialize();

	/**
	 * EBhẼbZ[W
	 *
	 * EBhE݂菈p
	 * EBhEꂽɏԂ
	 */
	void run();

private:

	/**
	 * Window classo^鎞̖
	 */
	static constexpr const TCHAR* WINDOW_CLASS_NAME = _T("KeyBindWindow");

	/**
	 * NCAg̈̕
	 */
	static constexpr int CLIENT_WIDTH = 872;

	/**
	 * NCAg̈̍
	 */
	static constexpr int CLIENT_HEIGHT = 678;

	/**
	 * ݒύX{^ID
	 *
	 * eL[oChΏۂ̃{^͔ԍIDɂĂ̂
	 * L[oChΏۂ̑傫KȒlgp
	 */
	static constexpr size_t ID_BUTTON_COMMIT = 100;

	/**
	 * L[͂\邽߂̃eLXgpobt@TCY
	 */
	static constexpr size_t KEY_TEXT_BUFFER_LENGTH = 64;

	/**
	 * L[oChΏۂ̋@\̖̂̃\[XID
	 */
	static const int KEY_BIND_NAME_RESOURCE_IDS[KeyBind::Index::LENGTH];
	
	/**
	 * oChꂽL[\ۂ̖
	 *
	 * nullptr̃L[͐ݒoȂ
	 */
	static const TCHAR* const VIRTUAL_KEY_NAMES[256];

	/**
	 * sς݃tO
	 */
	bool initialized_;

	/**
	 * bZ[WtO
	 */
	bool valid_;

	/**
	 * AvP[ṼCX^Xnh
	 */
	HINSTANCE instanceHandle_;

	/**
	 * EBhEnh
	 */
	HWND windowHandle_;

	/**
	 * eEBhẼnh
	 */
	HWND parentWindowHandle_;

	/**
	 * L[oChf[^
	 */
	KeyBind* keyBind_;

	/**
	 * ݒΏۂ̋@\\邽߂̗̈
	 */
	HWND targetTextHandle_;

	/**
	 * ݂̃L[͂\邽߂̗̈
	 */
	HWND currentKeyTextHandle_;

	/**
	 * ݒύX{^
	 */
	HWND commitButtonHandle_;

	/**
	 * L[oChΏۂ̋@\I邽߂̃{^
	 */
	HWND selectButtonHandles_[KeyBind::Index::LENGTH];

	/**
	 * oChꂽL[\邽߂̗̈
	 */
	HWND keyTextHandles_[KeyBind::Index::LENGTH];

	/**
	 * ݒΏۂ̋@\̔ԍ
	 */
	int targetIndex_;
	
	/**
	 * ݂̃L[
	 */
	WORD currentKey_;

	/**
	 * CL[̓͏
	 */
	WORD modifierKeyState_;

	/**
	 * L[͂\邽߂̃eLXgpobt@
	 */
	TCHAR keyTextBuffer_[KEY_TEXT_BUFFER_LENGTH];

	/**
	 * Window class̓o^1xsp̊֐
	 *
	 * Window class̓o^s
	 *
	 * @param instanceHandle AvP[ṼCX^Xnh
	 *
	 * @return Œ0Ԃ
	 */
	static int registerWindowClass(HINSTANCE instanceHandle);

	/**
	 * VXeR[obNEBhEvV[W
	 */
	static LRESULT WINAPI callbackProcedure(HWND windowHandle, UINT message, WPARAM wParam, LPARAM lParam);
	
	
	/**
	 * EBhEvV[We
	 */
	LRESULT procedure(HWND windowHandle, UINT message, WPARAM wParam, LPARAM lParam);

	/**
	 * oChꂽL[\p̕ɕϊ
	 *
	 * @param key L[
	 *
	 * @return eLXg܂ꂽobt@Ԃ
	 *         obt@̂̓NXLĂ̂œǏoł͎QƂ݂̂Ɏgp
	 */
	const TCHAR* keyBindToString(WORD key);
};
